VERTS=6 #圖形頂點數

class edge: #邊的組成宣告
    def __init__(self):
        self.start=0
        self.to=0
        self.find=0
        self.val=0
        self.next=None
'''
v[i]串列是紀錄頂點i在搜尋最小成本擴張樹過程中出現的次數
例如v[2]=3表示頂點B在實作找尋最小擴張樹的過程中已出現3次
'''
v=[0]*(VERTS+1) #因為要紀錄1~6六個頂點,但串列索引值從0開始,所以要多預留1個空間


def findmincost(head):  #搜尋成本最小的邊
    minval=100
    ptr=head
    while ptr!=None:
        if ptr.val<minval and ptr.find==0: #假如ptr.val的值小於minval
            minval=ptr.val                 #就把ptr.val設為最小值
            retptr=ptr                     #並且把ptr紀錄下來
        ptr=ptr.next #將指標往下移動
    retptr.find=1  #將retptr設為已找到的邊
    return retptr  #傳回retptr
        

def mintree(head):  #最小成本擴張樹函數
    global VERTS
    result=0
    ptr=head
    for i in range(VERTS):
        v[i]=0
    while ptr!=None:
        mceptr=findmincost(head) #搜尋成本最小的邊
        v[mceptr.start]=v[mceptr.start]+1 #找到最小成本的邊的起始頂點出現次數加1
        v[mceptr.to]=v[mceptr.to]+1 #找到最小成本的邊的終止頂點出現次數加1
        '''
        如果所找到最小成本的邊的起始頂點及終止頂點同時出現1次以上表示會形成迴路,
        所以直接跳過這個邊,要將剛才打算加入該邊的起始頂點及終止頂點出現次數各減1
        '''
        if v[mceptr.start]>1 and v[mceptr.to]>1: 
            v[mceptr.start]=v[mceptr.start]-1
            v[mceptr.to]=v[mceptr.to]-1
            result=1 #result這個旗標,用來辨識這個邊是否要略過,不要加入到最小成本邊
        else:
            result=0
        if result==0:
            print('起始頂點 [%d] -> 終止頂點 [%d] -> 路徑長度 [%d]' \
                  %(mceptr.start,mceptr.to,mceptr.val))
        ptr=ptr.next #將指標往下移動
            
#成本表陣列
data=[[1,2,6],[1,6,12],[1,5,10],[2,3,3], \
      [2,4,5],[2,6,8],[3,4,7],[4,6,11], \
      [4,5,9],[5,6,16]]
head=None
#建立圖形串列
for i in range(10):
    for j in range(1,VERTS+1):
        if data[i][0]==j:
            newnode=edge()
            newnode.start=data[i][0] #邊的起始頂點
            newnode.to=data[i][1] #邊的終止頂點
            newnode.val=data[i][2] #邊的成本
            newnode.find=0
            newnode.next=None
            if head==None:
                head=newnode
                head.next=None
                ptr=head
            else:
                ptr.next=newnode
                ptr=ptr.next
            
print('-------------------------------------------------')
print('建立最小成本擴張樹：')
print('-------------------------------------------------')
mintree(head)                        #建立最小成本擴張樹
